#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#include "adc/adc.h"
#include "wifi/wifi.h"
#include "converter/converter.h"
#include "leds/leds.h"


extern double saved_acc;
extern int boolean;
extern int counter;



int main()
{
	char buf[7];

	/*Configure leds on output*/
	init_leds();
	
	 /*Enable interrupts*/
	sei();

	/*Enable LCD*/
	LCD_init();
	DDRC |= (1 << PC2);
	PORTC |= (1 << PC2);

	/*Init wifi connection*/
	wifi_init();

	/*Start sensor*/
	prepare_and_start_sensor();

	while(1){
		/*delay for semaphore checking (SO stuff)*/
		_delay_ms(10);
		if(boolean > 0){
			/*Print sending Message*/
			LCD_clear_second_line();
			LCD_printAt(0x40, "Wait, sending");

			/*Convert and send data*/
			ftoa(saved_acc, buf, 2);
			wifi_send(buf);

			/*Reset sempahore*/
			boolean = 0;

			/*Print device ready to blow*/
			LCD_clear_second_line();
			LCD_printAt(0x40, "BLOW YOUR LUNGS");
		}
	};
}